function [VehicleLoadXaxis VehicleLoad SoCmaxTimeRecoreder]= FuncVehicleCharging20211004(FileName,Column,ChargingPower, SOC, BatteryCapacity, MinimisedTimeSlots)
%%**********Analysis and Recording****************************
EndLimit=2*86400;                              % this is the end time of simulation
%%************************************************************
BatteryCapacity01 = BatteryCapacity;           % [kWh]
BatteryCapacity=BatteryCapacity01;
SoC_int=SOC;                                   % The intitial battery state of charge
SoC_max= 1;                                    % The maximum battery state of charge
EffBattery=1;                                  % Battery efficiency
EffCharger =1;                                 % charger effciciency
TimeStep = 1;                                  % [Sec] the time sampling is 1 second
SoC=zeros(1,EndLimit);
SoE=zeros(1,EndLimit);
TimeIndex=1:1:EndLimit;
%%%***Mapping the minimized time slots of the vehcile to time vector*******
VehicleTimeSlotsVector=sort(MinimisedTimeSlots); %sort(MinimisedTimeSlots{1});
TimeVector=zeros(1,EndLimit);
%%*********Charging Event ************
DeltaTime=(1/2)*(3600); % the time lemgth of a time slot-half hour
StartTime = (VehicleTimeSlotsVector(1)-1)*DeltaTime+1;
EndTime=(VehicleTimeSlotsVector(end))*DeltaTime;
ChargingStartTime= StartTime;  %1*3600;        % [Sec] the time the vehvile charging starts
ChargingEndTime = EndTime;     %24*3600;       % [Sec] total second on 24 hours
SoC(ChargingStartTime-1)=SoC_int;
TimeTickSoCMax =ChargingStartTime;
      for TV=VehicleTimeSlotsVector
          DeltaTime=(1/2)*(3600);
          for Ticking=1:DeltaTime
          TimeVector((TV-1)*DeltaTime+Ticking)=1;
          end
      end
%%%%%%%% Starting  charging 
pp=0;
for t= ChargingStartTime:ChargingEndTime % ChargingStartTime:TimeStep:ChargingEndTime  
      if TimeVector(t)==1       
            if SoC(t-1) <= SoC_max           
               TimeTickSoCMax = TimeTickSoCMax + 1; % index for recording the soc status
                 pp=pp+1;
               SoC_instant = (1/BatteryCapacity)*(ChargingPower)*(EffCharger)*(EffBattery)*(TimeStep)/3600  ;
               SoC(t)= SoC(t-1) + SoC_instant;
               LastSoC=SoC(t);
               SoE_instant = (ChargingPower)*(EffCharger)*(EffBattery)*(TimeStep)/3600;   
               SoE(t)= (SoC(t-1)*BatteryCapacity) + SoE_instant;
               LastSOE=SoE(t);
             else
              SoCmaxTimeRecoreder = TimeTickSoCMax-1;  % this to recored the end of the charging
             break 
             end 
      else
          SoC(t)=LastSoC;
          SoE(t)=LastSOE;
          TimeTickSoCMax = TimeTickSoCMax + 1;
      end  
       SoCmaxTimeRecoreder = TimeTickSoCMax-1;       
 end
SoC(1:ChargingStartTime-1)= SoC_int;
SoC(SoCmaxTimeRecoreder+1:end)= SoC(SoCmaxTimeRecoreder);
%%%%***************************Energy**************************************
SoE(1:ChargingStartTime-1)= SoC_int*BatteryCapacity;
SoE(SoCmaxTimeRecoreder+1:end)= SoE(SoCmaxTimeRecoreder);
%**************************************************************************
X_SOC=(1/3600*TimeIndex(1:end));
Y_SOC= 100*SoC(1:end);
Y_SOE=SoE(1:end);
Y_Power=(3600)*gradient(Y_SOE(1:end));
%***********************Returning results*************************
Y_Power=Y_Power';
VehicleLoad =Y_Power;
VehicleLoadXaxis=X_SOC(1:172800)'; % Time resolution:(2*24*3600)
writematrix(Y_Power,FileName,'Sheet',1,'Range',[Column,num2str(2)]); % writes the chage of vehcile to the relevent column of the sheet